const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const audit_events = sequelize.define(
    'audit_events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

event_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"login",


"logout",


"file_uploaded",


"import_job_created",


"import_job_validated",


"import_job_imported",


"mapping_changed",


"rules_changed",


"template_downloaded"

        ],

      },

entity_name: {
        type: DataTypes.TEXT,
      
      

      },

entity_key: {
        type: DataTypes.TEXT,
      
      

      },

event_at: {
        type: DataTypes.DATE,
      
      

      },

metadata: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  audit_events.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























//end loop



    db.audit_events.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.audit_events.belongsTo(db.users, {
      as: 'actor',
      foreignKey: {
        name: 'actorId',
      },
      constraints: false,
    });

    db.audit_events.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.audit_events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.audit_events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return audit_events;
};


